"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AttachmentActions = void 0;
const axios = require('axios');
class AttachmentActions {
    static getBase64Content(url, token) {
        return __awaiter(this, void 0, void 0, function* () {
            let err_res = 'CA1:- D1--' + url + '--D2--' + token + '--';
            let response;
            try {
                let headers = {};
                if (token) {
                    headers = { Authorization: `Bearer ${token}` };
                }
                err_res = err_res + 'D3--' + JSON.stringify(headers) + '--';
                // arraybuffer is necessary for images
                response = yield axios.get(url, { headers: headers, responseType: 'arraybuffer' }); //, { responseType: 'arraybuffer' }); blob
                // If user uploads JSON file, this prevents it from being written as "{"type":"Buffer","data":[123,13,10,32,32,34,108..."
                if (response.headers['content-type'] === 'application/json') {
                    response.data = JSON.parse(response.data, (key, value) => {
                        return value && value.type === 'Buffer' ? Buffer.from(value.data) : value;
                    });
                }
            }
            catch (error) {
                return err_res;
            }
            return Buffer.from(response.data).toString('base64');
            // const asciiStr = String.fromCharCode.apply(null, response.data);
            // const base64Str = Buffer.from(asciiStr, 'base64');//btoa(asciiStr);
            // res = res + 'D2--' + response.data.length.toString();
            // res = res + 'D3--' + base64Str + '--!-!';
            // If no error was thrown while writing to disk, return the attachment's name
            // and localFilePath for the response back to the user.
            // return {
            //     fileName: attachment.name,
            //     localPath: localFileName
            // };
            // fs.writeFile(localFileName, response.data, (fsError) => {
            //     if (fsError) {
            //         throw fsError;
            //     }
            // });
        });
    }
}
exports.AttachmentActions = AttachmentActions;
