"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BotFrameworkAttachmentCustomActions = void 0;
const adaptive_expressions_1 = require("adaptive-expressions");
const botbuilder_dialogs_1 = require("botbuilder-dialogs");
const botframework_connector_1 = require("botframework-connector");
const attachmentActions_1 = require("./actions/attachmentActions");
class BotFrameworkAttachmentCustomActions extends botbuilder_dialogs_1.Dialog {
    constructor() {
        super(...arguments);
        this.url = new adaptive_expressions_1.StringExpression('');
        this.action = new adaptive_expressions_1.StringExpression('');
        this.channelId = new adaptive_expressions_1.StringExpression('');
        this.msAppId = new adaptive_expressions_1.StringExpression('');
        this.msAppPwd = new adaptive_expressions_1.StringExpression('');
    }
    getConverter(property) {
        switch (property) {
            case "url":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "action":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "channelId":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "msAppId":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "msAppPwd":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "resultProperty":
                return new adaptive_expressions_1.StringExpressionConverter();
            default:
                return super.getConverter(property);
        }
    }
    beginDialog(dc) {
        return __awaiter(this, void 0, void 0, function* () {
            const action = this.action.getValue(dc.state);
            let result;
            if (action === 'GET_BASE64_CONTENT') {
                let token = '';
                const channelId = this.channelId.getValue(dc.state);
                if (channelId == 'msteams' || channelId == 'skype') {
                    const credentials = new botframework_connector_1.MicrosoftAppCredentials(this.msAppId.getValue(dc.state), this.msAppPwd.getValue(dc.state));
                    //const credentials = new MicrosoftAppCredentials('32fc951d-383f-485b-be57-a71480ec6683', 'Yc67Q~~QaC39AMKrmDd6XUo54bOY5ukbbqCKV');
                    token = yield credentials.getToken(false);
                }
                result = yield attachmentActions_1.AttachmentActions.getBase64Content(this.url.getValue(dc.state), token);
                // // var contentBytes = new List<byte[]>();
                // using (var connectorClient = new ConnectorClient(new Uri(activity.ServiceUrl)))
                // {
                //     var token = await(connectorClient.Credentials as MicrosoftAppCredentials).GetTokenAsync();
                //     foreach (var content in attachments)
                //     {
                //         var uri = new Uri(content.Item2);
                //         using (var httpClient = new HttpClient())
                //         {
                //                 httpClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", token);
                //                 httpClient.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/octet-stream"));
                //             contentBytes.Add(await httpClient.GetByteArrayAsync(uri));
                //         }
                //     }
                // }
                // return contentBytes;
            }
            if (this.resultProperty) {
                dc.state.setValue(this.resultProperty.getValue(dc.state), result);
            }
            return dc.endDialog(result);
        });
    }
    onComputeId() {
        return "BotbuilderSamples.BotFrameworkAttachmentCustomActions";
    }
}
exports.BotFrameworkAttachmentCustomActions = BotFrameworkAttachmentCustomActions;
BotFrameworkAttachmentCustomActions.$kind = "BotbuilderSamples.BotFrameworkAttachmentCustomActions";
