"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BotFrameworkOAuthCustomActions = void 0;
const adaptive_expressions_1 = require("adaptive-expressions");
const botbuilder_dialogs_1 = require("botbuilder-dialogs");
const oAuthActions_1 = require("./actions/oAuthActions");
class BotFrameworkOAuthCustomActions extends botbuilder_dialogs_1.Dialog {
    constructor() {
        super(...arguments);
        this.action = new adaptive_expressions_1.StringExpression('');
        this.channelId = new adaptive_expressions_1.StringExpression('');
        this.connectionName = new adaptive_expressions_1.StringExpression('');
        this.userId = new adaptive_expressions_1.StringExpression('');
        this.msAppId = new adaptive_expressions_1.StringExpression('');
        this.msAppPwd = new adaptive_expressions_1.StringExpression('');
    }
    getConverter(property) {
        switch (property) {
            case "action":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "connectionName":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "userId":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "channelId":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "msAppId":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "msAppPwd":
                return new adaptive_expressions_1.StringExpressionConverter();
            case "resultProperty":
                return new adaptive_expressions_1.StringExpressionConverter();
            default:
                return super.getConverter(property);
        }
    }
    beginDialog(dc) {
        return __awaiter(this, void 0, void 0, function* () {
            const action = this.action.getValue(dc.state);
            let result;
            if (action === 'SIGNOUT') {
                result = yield oAuthActions_1.OAuthActions.signout(dc, this.userId.getValue(dc.state), this.connectionName.getValue(dc.state), this.msAppId.getValue(dc.state), this.msAppPwd.getValue(dc.state));
            }
            if (this.resultProperty) {
                dc.state.setValue(this.resultProperty.getValue(dc.state), result);
            }
            return dc.endDialog(result);
        });
    }
    onComputeId() {
        return "BotbuilderSamples.BotFrameworkOAuthCustomActions";
    }
}
exports.BotFrameworkOAuthCustomActions = BotFrameworkOAuthCustomActions;
BotFrameworkOAuthCustomActions.$kind = "BotbuilderSamples.BotFrameworkOAuthCustomActions";
