const axios = require('axios');

export class AttachmentActions {  
  public static async getBase64Content(url: string, token: string): Promise<string> {
    let err_res: string = 'CA1:- D1--' + url + '--D2--' + token + '--';
    let response;
    try {
      let headers = {};
      if (token) {
        headers = { Authorization: `Bearer ${token}` }
      }
      err_res = err_res + 'D3--' + JSON.stringify(headers) + '--';

      // arraybuffer is necessary for images
      response = await axios.get(url, {headers: headers, responseType: 'arraybuffer'});//, { responseType: 'arraybuffer' }); blob
      // If user uploads JSON file, this prevents it from being written as "{"type":"Buffer","data":[123,13,10,32,32,34,108..."
      if (response.headers['content-type'] === 'application/json') {
          response.data = JSON.parse(response.data, (key, value) => {
              return value && value.type === 'Buffer' ? Buffer.from(value.data) : value;
          });
      }
  } catch (error) {
      return err_res;
  }
  return Buffer.from(response.data).toString('base64');

  // const asciiStr = String.fromCharCode.apply(null, response.data);
  // const base64Str = Buffer.from(asciiStr, 'base64');//btoa(asciiStr);
  // res = res + 'D2--' + response.data.length.toString();

  // res = res + 'D3--' + base64Str + '--!-!';
  // If no error was thrown while writing to disk, return the attachment's name
  // and localFilePath for the response back to the user.
  // return {
  //     fileName: attachment.name,
  //     localPath: localFileName
  // };

  // fs.writeFile(localFileName, response.data, (fsError) => {
  //     if (fsError) {
  //         throw fsError;
  //     }
  // });
  
  }
}
