import { BotComponent } from "botbuilder";
import { BotFrameworkAttachmentCustomActions } from "./botFrameworkAttachmentCustomActions";
import { BotFrameworkOAuthCustomActions } from "./botFrameworkOAuthCustomActions";

import { ComponentDeclarativeTypes } from "botbuilder-dialogs-declarative";

import {
  ServiceCollection,
  Configuration,
} from "botbuilder-dialogs-adaptive-runtime-core";

// export function ping() {
//   return "hello there!";
// }

export default class BotFrameworkCustomActionsBotComponent extends BotComponent {  
  
  configureServices(
    services: ServiceCollection,
    _configuration: Configuration
  ): void {
    services.composeFactory<ComponentDeclarativeTypes[]>(
      "declarativeTypes",
      (declarativeTypes) =>
        declarativeTypes.concat({
          getDeclarativeTypes() {
            return [
              {
                kind: BotFrameworkAttachmentCustomActions.$kind,
                type: BotFrameworkAttachmentCustomActions,
              },
              {
                kind: BotFrameworkOAuthCustomActions.$kind,
                type: BotFrameworkOAuthCustomActions,
              },
            ];
          },
        })
    );
  }
}
